/*******************************************************************************
+
+  AGD 1.2
+
+
+  CGGridLayoutInfo.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                         CGGridLayoutInfo.h
//
//    author: Dirk Luetke-Huettmann
//    date:   may 1999
//-------------------------------------------------------------------


#ifndef _AGD_CG_GRIDLAYOUTINFO_H
#define _AGD_CG_GRIDLAYOUTINFO_H

#include <AGD/Cluster.h>
#include <AGD/GridLayoutInfo.h>
#include <AGD/CGGridLayout.h>

/*{\Manpage {CGGridLayoutInfo} {} {Grid Layout Infos for Cluster Graphs} {cggli} }*/ 

/*{\Mbaseclasses

\begin{hierarchy}{6.5}{2.5}
\hdclass{0.5}{1.5}{6.5}{GridLayoutInfo}
\arhook{7}{2}{8}
\hdclass{1.5}{0}{7}{CGGridLayoutInfo}
\end{hierarchy}
}*/

class __exportAGD CGGridLayoutInfo : public GridLayoutInfo {

/*{\Mdefinition The class |\Mname| extends the functionality of its
  base class |GridLayoutInfo| to access the attributes of a
  cluster graph grid layout for a cluster graph |CG|.}*/

public:

  /*{\Minitialization}*/

	CGGridLayoutInfo() { }
  /*{\Mcreate initializes a cluster graph grid layout info with |cggl|.}*/

  ~CGGridLayoutInfo() { }


  /*{\Moperations}*/

  virtual int x (leda::node v) const = 0;
  virtual int y (leda::node v) const = 0;

  virtual int x(Cluster* cl) const = 0;
  /*{\Mop returns the column of |cl| in the cluster graph grid layout.}*/

  virtual int y(Cluster* cl) const = 0;
  /*{\Mop returns the row of |cl| in the cluster graph grid layout.}*/

  virtual int width(Cluster* cl) const = 0;
  /*{\Mop returns the width of |cl| in the cluster graph grid layout.}*/

  virtual int height(Cluster* cl) const = 0;
  /*{\Mop returns the height of |cl| in the cluster graph grid layout.}*/


  /*const leda::list<Cluster*> get_clusters() const {
    return _cgglp->get_clusters();
  }*/
  /* {\Mop returns the list of all clusters in the cluster graph grid layout.}*/


};


#endif
