/*******************************************************************************
+
+  AGD 1.2
+
+
+  DefaultKeymapper.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                       DefaultKeymapper.h
//
//
//    author: Carsten Gutwenger
//    date:   octobre 1998
//-------------------------------------------------------------------


#if defined(_MSC_VER)
#pragma once
#endif

#ifndef _AGD_DEF_KEYMAPPER_H
#define _AGD_DEF_KEYMAPPER_H

#include <AGD/Keymapper.h>


/*{\Manpage {DefaultKeymapper} {} {Default Keymappers} {M} }*/

/*{\Mbaseclasses

\begin{hierarchy}{6.5}{2.5}
\hdclass{0}{1.5}{5}{Keymapper}
\arhook{5}{2}{6}
\hdclass{0.5}{0}{6}{DefaultKeymapper}
\end{hierarchy}
}*/

class __exportAGD DefaultKeymapper : public Keymapper {

/*{\Mdefinition
An instance |\Mvar| of type |\Mname| is a keymapper, which defines
string constants for all enumeration values of type |key::Predefined|.
A global default keymapper is used by class |AGD|. The predefined
strings are descibed in the manual page of class |AGD|
(see Sect.~\ref{AGD Base}).
}*/

	AgdKey *predef;
public:

	/*{\Mcreation 5}*/

	DefaultKeymapper();
	/*{\Mcreate creates an instances |\Mvar| of type |\Mtype|.}*/

	~DefaultKeymapper() {
		delete predef;
	}

	/*{\Moperations}*/
	/*{\Mtext All operations for keymappers are also available for
	default keymappers.}*/

	AgdKey predefined(key::Predefined k) const {
		return predef[k];
	}
	/*{\Mop converts |k| into a key of |\Mvar|.}*/
};


#endif
