/*******************************************************************************
+
+  AGD 1.2
+
+
+  DefaultRuleAdmin.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                          DefaultRuleAdmin.h
//
//
//    author: Carsten Gutwenger
//    date:   january 1999
//-------------------------------------------------------------------


#if defined(_MSC_VER)
#pragma once
#endif

#ifndef _AGD_DEF_RULE_ADMIN_H
#define _AGD_DEF_RULE_ADMIN_H


#include <AGD/RuleAdmin.h>
#include <AGD/DefaultKeymapper.h>


/*{\Manpage {DefaultRuleAdmin} {} {Default Rule Administrators} {A} }*/

/*{\Mbaseclasses

\begin{hierarchy}{6.5}{2.5}
\hdclass{0}{1.5}{5}{RuleAdmin}
\arhook{5}{2}{6}
\hdclass{0.5}{0}{6}{DefaultRuleAdmin}
\end{hierarchy}
}*/

class __exportAGD DefaultRuleAdmin : public RuleAdmin {

/*{\Mdefinition
An instance |\Mvar| of type |\Mname| is a rule administrator,
which defines a set of standard rules on predefined properties.
The standard rules are descibed in the manual page of
class |AGD| (see Sect.~\ref{AGD Base}).
}*/

public:

	/*{\Mcreation 5}*/

	DefaultRuleAdmin(const DefaultKeymapper &mapper);
	/*{\Mcreate creates an instances |\Mvar| of type |\Mtype|
	with associated default keymapper |mapper|.}*/

	~DefaultRuleAdmin() { }

private:
	void add_rule(const DefaultKeymapper &M, key::Predefined p1,
		key::Predefined q);
	void add_rule(const DefaultKeymapper &M, key::Predefined p1,
		key::Predefined p2, key::Predefined q);
	void add_rule(const DefaultKeymapper &M, key::Predefined p1,
		key::Predefined p2, key::Predefined p3, key::Predefined q);
};


#endif
