/*******************************************************************************
+
+  AGD 1.2
+
+
+  basic.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                         basic.h
//
//  This file defines basic definitions for AGD.
//
//    author: Carsten Gutwenger
//    date:   novembre 1999
//-------------------------------------------------------------------


#if defined(_MSC_VER)
#pragma once
#endif

#ifndef _AGD_BASIC_H
#define _AGD_BASIC_H


#include <LEDA/system/basic.h>

//
// AGD version macro
//

#define __AGD__ 120


//
// Building or using AGD as DLL
//

#if defined(AGD_DLL)

#if defined(AGD_INSTALL)
#define __exportAGD    __declspec(dllexport)
#define __exportAGDopt __declspec(dllimport)

#elif defined(AGDopt_INSTALL)
#define __exportAGD    __declspec(dllimport)
#define __exportAGDopt __declspec(dllexport)

#else
#define __exportAGD    __declspec(dllimport)
#define __exportAGDopt __declspec(dllimport)
#endif

#else
#define __exportAGD
#define __exportAGDopt


// The class AGD::Init is used for initializing static members
// of AGD if AGD is not used as DLL.
// You should never create instances of it!

class __exportAGD AGDInit {
	static int count;

public:
	AGDInit();

	~AGDInit();
};

static AGDInit __agd_init;

#endif


#ifdef _MSC_VER
inline int rint (double x)
{
  return (int)floor(x+0.5);
}
#endif


#endif
