/*******************************************************************************
+
+  AGD 1.2
+
+
+  CrossingsMatrix.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#ifndef _AGD_CROSSINGS_MATRIX_H
#define _AGD_CROSSINGS_MATRIX_H

#include <LEDA/core/array2.h>

class Layer;

class CrossingsMatrix {

public:
	CrossingsMatrix() : matrix(1,1) { }
	CrossingsMatrix(const leda::graph &G, const Hierarchy &H);

	~CrossingsMatrix();

	int operator()(int i, int j) const {
		return matrix(_map[i],_map[j]);
	}

	void swap(int i, int j) {
#if !defined(__HP_aCC)
		leda::swap(_map[i],_map[j]);
#else
                leda::swap(_map[i],_map[j]);
#endif
            }

	void init(const Layer &L);
  
private:
	int *_map;
	leda::array2<int> matrix;
};

#endif
