/*******************************************************************************
+
+  AGD 1.2
+
+
+  GCGridConceptBase.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                        GCGridConceptBase.h
//
//    author: Carsten Gutwenger
//    date:   july 1999
//-------------------------------------------------------------------


#ifndef _AGD_GCGC_BASE_H
#define _AGD_GCGC_BASE_H


#include <AGD/impl/GridConceptBase.h>
#include <AGD/IPolyline.h>
#include <AGD/PlaneGraphCopy.h>


class __exportAGD GCGridConceptBase : public GridConceptBase {

public:

	GCGridConceptBase() : _gcp(nil), _pgp(nil) { }
	GCGridConceptBase(GridLayout &gl, GraphCopy &GC) :
		GridConceptBase(gl), _gcp(&GC), _pgp(nil) { }
	GCGridConceptBase(const GCGridConceptBase &gcgcb) :
		GridConceptBase(gcgcb), _gcp(gcgcb._gcp), _pgp(gcgcb._pgp) { }

	~GCGridConceptBase() { }

	IPolyline get_bends(leda::edge e) const;

	GraphCopy &get_graph() const {
		return *_gcp;
	}

	void get_node_grid_size(const GridLayout &gl);

protected:

	GraphCopy      *_gcp;
	PlaneGraphCopy *_pgp;

	void transform (GridLayout &dest);
};


#endif
