/*******************************************************************************
+
+  AGD 1.2
+
+
+  Ortho_common.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



//#line 28 "Lweb/OrthoRep.lw"
#ifndef AGD_ORTHO_COMMON_H
#define AGD_ORTHO_COMMON_H

#include <LEDA/core/tuple.h>

enum direction { N_, W_, S_, E_, unexplored_ };

inline direction opp_(direction d) { 
  if (d == unexplored_) return d; 
  return (direction)((d+6) % 4); 
}

inline direction next_(direction d) { 
  if (d == unexplored_) return d; 
  return (direction)((d+5) % 4); 
}

inline direction prev_(direction d) { 
  if (d == unexplored_) return d;
  return (direction)((d+3) % 4); 
}

typedef leda::three_tuple<double, double, leda::node> triple;
typedef leda::two_tuple<leda::node, leda::node> node_pair;
typedef leda::two_tuple<int, int> int_pair;

#endif

