/************************************************************************

         Filename   :   pqQueue.h
         Version    :   1.0 1997
         Author     :   Sebastian Leipert
         Language   :   C++

************************************************************************/ 
#ifndef PQQUEUE_H
#define PQQUEUE_H
#include <LEDA/internal/std/stdio.h>
#include <LEDA/internal/std/stdlib.h>
#include "def.inc"



template<class T> class pqQueue;

template<class T>
class Q_element{
   friend class pqQueue<T>;

   private:
   T           key;
   Q_element  *next;
   Q_element  *pre;
};




template <class T>

class pqQueue {
     Q_element<T>  *first;
     Q_element<T>  *last; 
     int        size;     
public:
           pqQueue();             
          ~pqQueue();            

     void  cleanupQueue(); 
     T     deQueue();         
     void  enQueue(T m);   
     T     front();                          
     int   queueEmpty();   
     int   queueSize();     
};


template<class T> void pqQueue<T>::cleanupQueue()
{
   Q_element<T>   *helpptr;

   while (last != NULL)
   {
      helpptr = last;
      last = last->next;
      delete helpptr;
   } 
   first = NULL;
   size = 0;
} // empty_queue


template<class T> pqQueue<T>::pqQueue()
{
   first = NULL;
   last = NULL;
   size = 0;
} // constructor


template<class T> pqQueue<T>::~pqQueue()
{
  Q_element<T>  *helpptr;

  while (last != NULL)
  {
     helpptr = last;
     last = last->next;
     delete helpptr;
  } 
} // destructor


template<class T> T pqQueue<T>::deQueue()
{
    T             helpelem;
    Q_element<T>  *helpptr;

    if (last != NULL)
    {
       if (first == last)
          first = NULL;
       helpelem = last->key;
       helpptr = last;
       last = last->next;
       if (last != NULL)
          last->pre = NULL;
       size--;
       delete helpptr;
       return helpelem;
    } 
    else
    {
       printf("template pqQueue: pqQueue empty. wrong access\n");
       return 0;
    } 
} // dequeue


template<class T> void pqQueue<T>::enQueue(T m)
{
  Q_element<T>   *helpptr;

  size++;
  helpptr = new Q_element<T>;
  helpptr->key = m;
  helpptr->next = NULL;
  if (last == NULL)
  {
     last = helpptr;
     first = helpptr;
     helpptr->pre = NULL;
  } 
  else
  {
     first->next = helpptr;
     helpptr->pre = first;
     first = helpptr;
  } 
} // enqueue


template<class T> T pqQueue<T>::front()
{
   if (last != NULL)
      return last->key;
   else
   {
      printf("template pqQueue: ");
      printf("pqQueue empty. wrong access when reading element.\n");
      return 0;
   } 
} // front


template<class T> int pqQueue<T>::queueEmpty()
{
   if (size == 0)
      return TRUE;
   else
      return FALSE;
} // queue_empty


template<class T> int pqQueue<T>::queueSize()
{
   return size;
} // queue_size



#endif



