/************************************************************************

         Filename   :   pqQueue.h
         Version    :   1.0 1997
         Author     :   Sebastian Leipert
         Language   :   C++

************************************************************************/ 
#ifndef PQQUEUE_H
#define PQQUEUE_H
#include <LEDA/internal/std/stdio.h>
#include <LEDA/internal/std/stdlib.h>
#include "def.inc"



template<class T> class pqQueue;

template<class T>
class Q_element{
   friend class pqQueue<T>;

   private:
   T           key;
   Q_element  *next;
   Q_element  *pre;
};




template <class T>

class pqQueue {

     Q_element<T>  *first;
     Q_element<T>  *last; 
     int        size;     

public:

void pqQueue<T>::cleanupQueue()
{
   Q_element<T>   *helpptr;

   while (last != NULL)
   {
      helpptr = last;
      last = last->next;
      delete helpptr;
   } 
   first = NULL;
   size = 0;
} // empty_queue


pqQueue()
{
   first = NULL;
   last = NULL;
   size = 0;
} // constructor


~pqQueue()
{
  Q_element<T>  *helpptr;

  while (last != NULL)
  {
     helpptr = last;
     last = last->next;
     delete helpptr;
  } 
} // destructor


T deQueue()
{
    T             helpelem;
    Q_element<T>  *helpptr;

    if (last != NULL)
    {
       if (first == last)
          first = NULL;
       helpelem = last->key;
       helpptr = last;
       last = last->next;
       if (last != NULL)
          last->pre = NULL;
       size--;
       delete helpptr;
       return helpelem;
    } 
    else
    {
       printf("template pqQueue: pqQueue empty. wrong access\n");
       return 0;
    } 
} // dequeue


void enQueue(T m)
{
  Q_element<T>   *helpptr;

  size++;
  helpptr = new Q_element<T>;
  helpptr->key = m;
  helpptr->next = NULL;
  if (last == NULL)
  {
     last = helpptr;
     first = helpptr;
     helpptr->pre = NULL;
  } 
  else
  {
     first->next = helpptr;
     helpptr->pre = first;
     first = helpptr;
  } 
} // enqueue


T front()
{
   if (last != NULL)
      return last->key;
   else
   {
      cout << "template pqQueue: "
           << "pqQueue empty. wrong access when reading element."
           << endl;
      return 0;
   } 
} // front


int queueEmpty()
{
   if (size == 0)
      return TRUE;
   else
      return FALSE;
} // queue_empty


int queueSize()
{
   return size;
} // queue_size


};

#endif



