/*********************************************************************

  FILENAME  : clusterGraph.cc
  VERSION   : 1.0.0
  AUTHOR    : Christoph Liebel
  LANGUAGE  : C++

*********************************************************************/

#ifndef CLUSTERGRAPH_H
#define CLUSTERGRAPH_H

#include "AGD/impl/planarity/basicGraph.h"
#include "AGD/ClusterGraph.h"
#include "AGD/impl/cplanarity/inclusionTree.h"
#include "AGD/impl/cplanarity/linkedList.h"



class clusterGraph : public basicGraph {

  public:

    clusterGraph();
    clusterGraph(const clusterGraph&);
    virtual ~clusterGraph();

    virtual int  constructC_Graph(const ClusterGraph& C);
    virtual void deleteGraph();
    basicList<outEdge>* getAdjList() const;
    basicList<outEdge>* getAdjList(int number) const;
    linkedList<int>* getC_Nodes() const;
    char* getGraphName();
    int getM() const;
    int getN() const;
    inclusionTree* getTree() const;
    const clusterGraph& operator=(const clusterGraph&);

  protected:

    int              clusterNumber;
    inclusionTree*   tree;
    linkedList<int>* c_Nodes;



  private:

    treeElement* constructTree(int cNumber, int position = 0);



};

#endif


