/*********************************************************************

  FILENAME  : inclusionTree.h
  VERSION   : 1.0.0
  AUTHOR    : Christoph Liebel
  LANGUAGE  : C++

*********************************************************************/

#ifndef INCLUSIONTREE_H
#define INCLUSIONTREE_H

class treeElement {

  friend class inclusionTree;
  friend class clusterGraph;

  int item;
  treeElement* parent;
  treeElement* next;
  treeElement* child;
};

class inclusionTree {

    friend class clusterGraph;

  public:

    inclusionTree();
    virtual ~inclusionTree();

    virtual void  clear(treeElement* helpPtr);
    treeElement*  getActual() const;
    treeElement*  getChild(treeElement* elementPtr) const;
    int           getCount() const;
    int           getItem(treeElement* elementPtr) const;
    treeElement*  getNext(treeElement* elementPtr) const;
    treeElement*  getParent(treeElement* elementPtr) const;
    treeElement*  getRoot() const;
    virtual void  insert(int newItem, int sibling = 0);
    void          postorderOut(treeElement*) const;




  protected:

    treeElement*  actual;
    treeElement*  root;
    int           count;


};


#endif

