/********************************************************************

  FILENAME  : linkedList.h
  VERSION   : 03.09. / 1 
  AUTHOR    : Christoph Liebel
  LANGUAGE  : C++

********************************************************************/

#ifndef LINKEDLIST_H
#define LINKEDLIST_H

#include <AGD/impl/planarity/basicList.h>
#include <LEDA/internal/std/iostream.h>


template <class T> class linkedList
   : public basicList<T> {

   typedef basicList<T> baseclass;

  public:
       
    linkedList();
    ~linkedList();

    element<T>* copyToTop(basicList<T>* otherList);
    element<T>* getActual() const;
    element<T>* getFirst() const;
    int remove(element<T>* deleteElement, element<T>* prevElement);


};

/*****************************************************************************/
/*****************************            ************************************/
/***************************** linkedList ************************************/
/*****************************            ************************************/
/*****************************************************************************/

template<class T>
linkedList<T>::linkedList()
    : basicList<T>()
{}

/*****************************************************************************/
/*****************************             ***********************************/
/***************************** ~linkedList ***********************************/
/*****************************             ***********************************/
/*****************************************************************************/

template<class T>
linkedList<T>::~linkedList()
{
  basicList<T>::clear();
}

/*****************************************************************************/
/*****************************           *************************************/
/***************************** copyToTop *************************************/
/*****************************           *************************************/
/*****************************************************************************/

template<class T>
element<T>* linkedList<T>::copyToTop(basicList<T>* otherList)
{
    element<T>* newFirst, * lastElement, * newElement;
    T actualItem;

    otherList->reset();
    if (!otherList->out(actualItem)) return NULL;

    newFirst = lastElement = newElement = new element<T>;
    newElement->item = actualItem;
    this->size++;

    while (otherList->out(actualItem))
        {
            newElement = new element<T>;
            newElement->item = actualItem;
            this->size++;
            lastElement->next = newElement;
            lastElement = newElement;
        }

    lastElement->next = this->first;
    this->first = newFirst;

    return lastElement;
}

/*****************************************************************************/
/*****************************           *************************************/
/***************************** getActual *************************************/
/*****************************           *************************************/
/*****************************************************************************/

template<class T>
element<T>* linkedList<T>::getActual() const
{
    return this->actual;
}

/*****************************************************************************/
/*****************************          **************************************/
/***************************** getFirst **************************************/
/*****************************          **************************************/
/*****************************************************************************/

template<class T>
element<T>* linkedList<T>::getFirst() const
{
  return baseclass::first;
}

/*****************************************************************************/
/*****************************        ****************************************/
/***************************** remove ****************************************/
/*****************************        ****************************************/
/*****************************************************************************/

template<class T>
int linkedList<T>::remove(element<T>* deleteElement, element<T>* prevElement)
{
    if (deleteElement == baseclass::actual)
        baseclass::actual = deleteElement->next;

    if (deleteElement == prevElement && deleteElement == baseclass::first)
        baseclass::first = deleteElement->next;
    else if (deleteElement == prevElement || prevElement->next != 
             deleteElement)
        {
            return 0;
        }
    else
        prevElement->next = deleteElement->next;

    delete deleteElement;
    this->size--;
    return 1;
}



#endif

