//-------------------------------------------------------------------
//
//                          IOPoints1.h
//
//    purpose: defines class MMOrder
//             implements management of the ordered partition
//
//    author: Carsten Gutwenger
//    date:   june 1998
//-------------------------------------------------------------------


#ifndef _MMOrder_H
#define _MMOrder_H


#include <AGD/CanonicalOrder.h>
#include <AGD/PlaneGraphCopy.h>


using namespace leda;

struct MMOrder {

	MMOrder() { }

	void init(PlaneGraphCopy &PG, CanonicalOrderType ct, face f,
		bool prefer_nodes, double base_ratio);/*
	{
		lmc = LmcOrder (PG, ct, f, prefer_nodes, base_ratio);
		left = right = array<node>(1,lmc.length());
	}*/

	int rank (node v) const {
		return lmc.rank(v);
	}

	int length() const {
		return lmc.length();
	}

	const OrderSet &operator[](int k) const {
		return lmc[k];
	}

	node operator()(int k, int i) const {
		return lmc(k,i);
	}

	int len (int k) const {
		return lmc.len(k);
	}

	array<node> left, right;


private:

	LmcOrder lmc;
};



#endif
