/*******************************************************************************
+
+  AGD 1.2
+
+
+  OrthogonalRepresentationGridConcept.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



//#line 1584 "Lweb/OrthoRep.lw"
#include <AGD/GridLayoutModule.h>
#include <AGD/GraphGLI.h>
#include <AGD/GraphCopyGLI.h>
#include <AGD/LayoutInterface.h>

#include <AGD/OrthogonalRepresentation.h>
#include <AGD/OrthoRepGridConcept.h>


using namespace leda;

//-------------------------------------------------------------------
//                       OrthoRepGridConcept
//-------------------------------------------------------------------

OrthoRepGridConcept::OrthoRepGridConcept 
  (const graph &G, LayoutInterface &) : new_graph(true), new_layout(true)
{
        _gcp = _porp = new OrthogonalRepresentation(G, nil);
        _glp = new GridLayout(*_porp);
}
        
OrthoRepGridConcept::OrthoRepGridConcept (const graph &G, face f, LayoutInterface &) : new_graph(true), new_layout(true) {

  //  face _ext_face = (f != nil) ? _porp->copy_of_face(f) : nil;
  
  _gcp = _porp = new OrthogonalRepresentation(G, f);//_ext_face);
  _glp = new GridLayout(*_porp);
}

OrthoRepGridConcept::OrthoRepGridConcept
  (OrthogonalRepresentation &H, LayoutInterface &) : 
    _porp(&H), new_graph(false), new_layout(true)
{
        _gcp = _porp;
        _glp = new GridLayout(H);
}

OrthoRepGridConcept::OrthoRepGridConcept 
  (const graph &G, GridLayout &) : 
    new_graph(true), new_layout(true)
{
        _gcp = _porp = new OrthogonalRepresentation(G, nil);
        _glp = new GridLayout(*_porp);
}

OrthoRepGridConcept::OrthoRepGridConcept
  (const graph &G, face f, GridLayout &) : 
    new_graph(true), new_layout(true)
{
  //face _ext_face =  (f != nil) ? _porp->copy_of_face(f) : nil;
  _gcp = _porp = new OrthogonalRepresentation(G, f);//_ext_face);
  _glp = new GridLayout(*_porp);
        
}


//OrthoRepGridConcept::OrthoRepGridConcept
//  (const graph &G, face f, GridLayout &gl, list<Label> &Lambda) : 
//    new_graph(true), new_layout(true)
//{
//  //face _ext_face =  (f != nil) ? _porp->copy_of_face(f) : nil;
//  _gcp = _porp = new OrthogonalRepresentation(G, f);//_ext_face);
//  _glp = new GridLayout(*_porp);
//  _Lp  = &Lambda;
      
//}



// OrthoRepGridConcept::OrthoRepGridConcept
//   (OrthogonalRepresentation &H, GridLayout &gl) : 
//     _porp(&H), new_graph(false), new_layout(false)
// {
//   _gcp = _porp;
//   _glp = &gl;
//   gl.init(H);
// }


OrthoRepGridConcept::~OrthoRepGridConcept()
{
        if (new_graph)  delete _porp;
        if (new_layout) delete _glp;
}


void OrthoRepGridConcept::get_node_grid_size
(GridCoordinateMapper &gcm, const LayoutInterface &A) {

  if (new_graph) {
    GraphCopyGLI gli(*this);
    gcm.get_node_grid_size (gli, A);
  } else {
    GraphGLI gli(*_glp);
    gcm.get_node_grid_size (gli, A);
  }
}

void OrthoRepGridConcept::update (GridCoordinateMapper &gcm,
        LayoutInterface &A)
{
  if (new_graph) {
    GraphCopyGLI gli(*this);
    gcm.call (gli, A);
  } else {
    GraphGLI gli(*_glp);
    gcm.call (gli, A);
  }
  A.update();
}

void OrthoRepGridConcept::update (GridLayout &gl)
{
        if (!new_layout) return;

        transform (gl);
}


void OrthoRepGridConcept::set_postcondition(list<AgdKey> &post)
{
	post.append(key::planar_map_callable);
	post.append(key::PlaneGraphCopy_callable);
}
