
#OBJECTS = `find src -name "*.obj"`
OBJECTS = `find src -name "*.obj" | grep -v geowin`

OBJECTS1 = `find src -name "*.o"`


leda.lib: $(compiler).tag

agd: $(compiler).agd


g++.tag: 
	@echo " "
	@echo "Building leda.dll"
	@echo " "
	gcc -shared -o leda.dll -Wl,--whole-archive $(OBJECTS1) -Wl,--no-whole-archive -lkernel32 -luser32 -lgdi32 -lmsimg32 -lshell32 -lcomdlg32 -ladvapi32 -lwsock32 -lopengl32 -lstdc++
	touch g++.tag


bcc.tag:
	@echo " "
	@echo Building DLL "leda.dll" and library "leda.lib"
	@echo " "
	bcc32 -tWD -eleda.dll $(OBJECTS)
	implib -w -c leda.lib leda.dll
#	rm -f G-DLEDA_DLLeoWin.lib
#	tlib GeoWin.lib /C /P128 @src\\graphics\\GeoWin\\tlib.lst
	touch bcc.tag



bccg.tag:
	@echo " "
	@echo Building DLL "leda.dll" and library "leda.lib"
	@echo " "
	bcc32 -vG -v -tWD -eleda.dll $(OBJECTS)
	implib -w -c leda.lib leda.dll
#	rm -f GeoWin.lib
#	tlib GeoWin.lib /C /P128 @src\\graphics\\GeoWin\\tlib.lst
	touch bccg.tag


msc.agd:
	echo " "
	echo Building library "agd.lib"
	echo " "
	lib -nologo -out:agd.lib src\\*\\*.obj
	touch msc.tag

msc.tag:
	echo " "
	echo Building DLL "leda.dll" and library "leda.lib"
	echo " "
	cl -LD -Feleda $(OBJECTS) user32.lib gdi32.lib msimg32.lib shell32.lib comdlg32.lib advapi32.lib wsock32.lib opengl32.lib
 	lib -nologo -out:GeoWin.lib src\\graphics\\GeoWin\\*.obj
	touch msc.tag


mscg.tag:
	echo " "
	echo Building DLL "leda.dll" and library "leda.lib"
	echo " "
	cl -Zi -LD -Feleda $(OBJECTS) user32.lib gdi32.lib msimg32.lib shell32.lib comdlg32.lib advapi32.lib wsock32.lib opengl32.lib
 	lib -nologo -out:GeoWin.lib src\\graphics\\GeoWin\\*.obj
	touch mscg.tag



wcc.tag:
	echo " "
	echo Building DLL "leda.dll" and library "leda.lib"
	echo " "
	wcl386 -x -l=nt_dll -fe=leda.dll $(OBJECTS)
	wlib -q -c leda.lib + leda.dll
#	if [ -d src/graphics/GeoWin ]; then \
#	wlib -b -c -q -p=512 GeoWin.lib @src\\graphics\\GeoWin\\wlib.lst; fi
	touch wcc.tag


wccg.tag:
	echo " "
	echo Building DLL "leda.dll" and library "leda.lib"
	echo " "
	wcl386 -d2 -x -l=nt_dll -fe=leda.dll $(OBJECTS)
	wlib -q -c leda.lib + leda.dll
	cp confdir/cygwin/cmd/wcc_lib .
#	if [ -d src/graphics/GeoWin ]; then \
#	wlib -b -c -q -p=512 GeoWin.lib @src\\graphics\\GeoWin\\wlib.lst; fi
	touch wccg.tag
	
	

mwc.tag:
	cp confdir/cygwin/cmd/msc_lib .
	mwld -shared -export dllexport -o leda.dll $(OBJECTS) -lkernel32.lib -luser32.lib -lgdi32.lib -lmsimg32.lib -lshell32.lib -lcomdlg32.lib -ladvapi32.lib -lwsock32.lib
#	mwld -library -o GeoWin.lib src/graphics/GeoWin/*.obj
	touch mwc.tag



