@ECHO OFF
REM Dieses Skript erzeugt die InnoSetup Datei, aus der anschlieend das Setup-
REM Programm gebaut wird
if not "%4" == "" goto :skip_usage
echo usage build_iss_file cc vers package_size kind_of_package
goto :quit

:skip_usage

REM wir bentigen einige Strings, fr den [SETUP] Teil der iss-Datei
set ver=%2
set copy=2008

set package_size=complete

set edition=%3

set kind_package=%4


set s_header=std

set multithread=""
::set multithread="multithreading"



REM baue die Applikationsnamen zusammen
set appname=LEDA %ver%

if "%edition%"=="free" set appname=%appname% Free
if "%package_size%"=="AGD-1.2" set appname=%appname% and AGD-1.2
if "%package_size%"=="complete" set appname=%appname% GUI
if "%package_size%"=="geometry" set appname=%appname% Geometry
if "%package_size%"=="graph" set appname=%appname% Graph
if "%package_size%"=="basic" set appname=%appname% Basic

if "%kind_package%"=="eval" set appname=%appname% Evaluation
if "%kind_package%"=="private_user" set appname=%appname% Private User

set appname=%appname% Package

if "%multithread%"=="multithreading" set appname=%appname% thread safe

if "%1"=="msc60" set s_header=""
if "%1"=="bcc551" set s_header=""
if "%1"=="bcc56" set s_header=""
if "%s_header%"=="std" set appname=%appname% with Standard Headers

REM Baue den dirname, er wird das sptere Installationsverzeichnis

if "%edition%"=="free" set dirname=LEDA-%ver%-%edition%-win32-%1%
if "%edition%"=="nofree" set dirname=LEDA-%ver%-win32-%1%
if "%kind_package%"=="eval" set dirname=%dirname%-eval
if "%kind_package%"=="private_user" set dirname=%dirname%-pu

if "%s_header%"=="std" set dirname=%dirname%-%s_header%
if "%multithread%"=="multithreading" set dirname=%dirname%-multithread

::set compiler name
if "%1"=="bcc551" set comp=Borland C++ 5.5.1
if "%1"=="bcc56" set comp=Borland C++ 5.6
if "%1"=="msc60" set comp=Microsoft Visual C++ 6.0
if "%1"=="msc70" set comp=Microsoft Visual C++ .NET 2002
if "%1"=="msc71" set comp=Microsoft Visual C++ .NET 2003
if "%1"=="msc8"  set comp=Microsoft Visual C++ .NET 2005
if "%1"=="msc9"  set comp=Microsoft Visual C++ .NET 2008
if "%1"=="msc10"  set comp=Microsoft Visual C++ .NET 2010
if "%1"=="msc11"  set comp=Microsoft Visual C++ .NET 2012
if "%1"=="msc12"  set comp=Microsoft Visual C++ .NET 2013
if "%1"=="msc14"  set comp=Microsoft Visual C++ .NET 2015
if "%1"=="msc15"  set comp=Microsoft Visual C++ .NET 2017
if "%1"=="msc16"  set comp=Microsoft Visual C++ .NET 2019

set lib=dll

REM Der erste Teil der iss Datei sind [Setup] Informationen
echo.
echo [Setup]
echo Appname=%appname% for %comp%
echo AppVerName=%appname%
echo DefaultDirName={sd}\Algorithmic Solutions\%dirname%
echo DefaultGroupName=%dirname%
echo MinVersion=5.0
echo LicenseFile=license.txt
echo Compression=bzip/9
echo AppCopyright=Copyright  %copy% Algorithmic Solutions Software GmbH
::echo AdminPrivilegesRequired=yes
REM %dirname% is actually the package name and will be the name of the setup program
echo OutputBaseFilename=%dirname%
echo.

REM die verschiedenen Installationstypen
echo [Types]
echo Name: full; Description: Full installation
echo Name: minimal; Description: Minimal installation
echo Name: custom; Description: Custom installation; Flags: iscustom
echo.

REM die verschiedenen Komponenten der Installation
echo [Components]
echo Name: main; Description: Main Files; Types: full minimal custom; Flags: fixed

if "%1"=="bcc551" goto :borland_comp
if "%1"=="bcc56"  goto :borland_comp
if "%1"=="msc8"   goto :msc8_comp
if "%1"=="msc9"   goto :msc8_comp
if "%1"=="msc10"   goto :msc8_comp
if "%1"=="msc11"   goto :msc8_comp
if "%1"=="msc12"   goto :msc8_comp
if "%1"=="msc14"  goto :msc8_comp
if "%1"=="msc15"  goto :msc8_comp
if "%1"=="msc16"  goto :msc8_comp

::Microsoft part
if "%kind_package%"=="eval" goto :eval_components



:msc67_comp
echo Name: DLLs_ml; Description: Dynamic Link Libraries with Compiler Option /ML; Types: full
echo Name: DLLs_mld; Description: Dynamic Link Libraries with Compiler Option /MLd; Types: full minimal
echo Name: DLLs_md; Description: Dynamic Link Libraries with Compiler Option /MD; Types: full
echo Name: DLLs_mdd; Description: Dynamic Link  Libraries with Compiler Option /MDd; Types: full
echo Name: DLLs_mt; Description: Dynamic Link  Libraries with Compiler Option /MT; Types: full
echo Name: DLLs_mtd; Description: Dynamic Link  Libraries with Compiler Option /MTd; Types: full
goto :all_comp_part

:msc8_comp
echo Name: DLLs_md; Description: Dynamic Link Libraries with Compiler Option /MD; Types: full
echo Name: DLLs_mdd; Description: Dynamic Link  Libraries with Compiler Option /MDd; Types: full
echo Name: DLLs_mt; Description: Dynamic Link  Libraries with Compiler Option /MT; Types: full
echo Name: DLLs_mtd; Description: Dynamic Link  Libraries with Compiler Option /MTd; Types: full
goto :all_comp_part

:msc9_comp
echo Name: DLLs_md; Description: Dynamic Link Libraries with Compiler Option /MD; Types: full
echo Name: DLLs_mdd; Description: Dynamic Link  Libraries with Compiler Option /MDd; Types: full
echo Name: DLLs_mt; Description: Dynamic Link  Libraries with Compiler Option /MT; Types: full
echo Name: DLLs_mtd; Description: Dynamic Link  Libraries with Compiler Option /MTd; Types: full
goto :all_comp_part

:eval_components
echo Name: DLLs_mdd; Description: Dynamic Link  Libraries with Compiler Option /MDd; Types: full

goto :all_comp_part
:borland_comp
echo Name: Libs; Description: Static Libraries; Types: full minimal

::not used!!!
::echo Name: DLLs; Description: Dynamic Link Libraries; Types: full minimal
::echo Name: DLLs_d; Description: Dynamic Link Libraries with Debug Information; Types: full

:all_comp_part
echo Name: Demos; Description: Demo Programs; Types: full
echo Name: Tests; Description: Test Programs; Types: full
REM echo Name: Manual; Description: html-Manual; Types: full minimal
echo. 

REM am Schlu der Installation bekommen wir das readme gezeigt! (P.S. Das geht auch schner,
REM als ber [Run]



REM jetzt beginnt die wichtigste und grte Sektion, die Dateien der Installation
echo [Files]

REM fr AGD-1.2 und complete wollen wir die .hlp Dateien
if  "%package_size%"=="AGD-1.2" goto :add_help_files
if  "%package_size%"=="complete" goto :add_help_files
goto :skip_help_files

:add_help_files
REM alle .htlp-Dateien hinzufgen!
echo Source: "incl\HELP\*.hlp";        DestDir: "{app}\incl\HELP"; Excludes: "\CVS"; Flags:RecurseSubDirs; Components: Demos Tests
echo.


:skip_help_files
REM alle  Dateien aus incl\LEDA
if "%package_size%"=="graph" goto :graph_package_includes
if "%package_size%"=="geometry" goto :geo_package_includes
goto :full_includes
:full_includes
echo Source: "incl\LEDA\*"; DestDir: "{app}\incl\LEDA"; Flags: RecurseSubDirs; Excludes: "\event_old,\CVS"; Components: main
echo.
REM brauchen wir die AGD-headers?
if "%package_size%"=="AGD-1.2" goto :add_agd_headers
goto :skip_agd_headers

:graph_package_includes
echo Source: "incl\LEDA\*"; DestDir: "{app}\incl\LEDA"; Flags: RecurseSubDirs; Excludes: "\event_old,\CVS,\anim,\geo,\graphics"; Components: main
echo Source: "incl_old\LEDA\*"; DestDir: "{app}\incl_old\LEDA"; Flags: RecurseSubDirs; Excludes: "\CVS"; Components: main
echo.
REM brauchen wir die AGD-headers?
goto :skip_agd_headers
:geo_package_includes
echo Source: "incl\LEDA\*"; DestDir: "{app}\incl\LEDA"; Flags: RecurseSubDirs; Excludes: "\event_old,\CVS,\graphics,\anim"; Components: main
echo Source: "incl_old\LEDA\*"; DestDir: "{app}\incl_old\LEDA"; Flags: RecurseSubDirs; Excludes: "\CVS"; Components: main
echo.
REM brauchen wir die AGD-headers?
goto :skip_agd_headers
:add_agd_headers
REM alle Dateien in AGD\incl\AGD
REM rekursiv alle Dateien unterhalb incl\AGD\impl
echo Source: "AGD\incl\AGD\*; DestDir:"{app}\AGD\incl\AGD"; Flags: RecurseSubDirs; Excludes: "\CVS"; Components: main
REM alle .txt Dateien in AGD
REM alle .txt Dateien in AGD\Install
REM alle Dateien in AGD\man_html
echo Source: "AGD\*.txt"; DestDir:"{app}\AGD"; Flags: RecurseSubDirs; Excludes: "\CVS"; Components: main
REM alle .txt Dateien in demo\agd\agd\server_docs
echo Source: "AGD\demo\agd\agd_server_docs\*.txt"; DestDir: "{app}\demo\agd\agd_server_docs\"; Components: main
REM alle Dateien in demo\agd
echo Source:"demo\agd\*"; DestDir: "{app}\demo\agd"; Flags: RecurseSubDirs; Excludes: "\CVS"; Components: Demos

echo.

:skip_agd_headers
REM testen, ob wir die source Dateien in demo brauchen
if "%package_size%"=="complete" goto :add_demo_source
if "%package_size%"=="AGD-1.2" goto :add_demo_source
goto :basic_tests

:add_demo_source
REM wir fgen die demo source Dateien hinzu

REM rekursiv alle .c Dateien unterhalb demo/
echo Source: "demo\*.cpp"; DestDir:"{app}\demo"; Flags: RecurseSubDirs; Excludes:"\anim,\CVS"; Components: Demos
REM rekursiv alle Make-Dateien unterhalb demo/
echo Source: "demo\?ake*"; DestDir:"{app}\demo"; Flags: RecurseSubDirs; Excludes:"\CVS"; Components: Demos


REM die folgenden Dateien in demo\animation\...
echo Source:"demo\anim\*"; DestDir: "{app}\demo\anim"; Flags: RecurseSubDirs; Excludes:"\CVS"; Components: Demos

REM die Make.pro Datei in demo/
echo Source: "demo\Make.pro";    	DestDir: "{app}\demo"; Components: Demos

REM bauen wir fr Microsoft, dann wollen wir die demo-workspaces!
if "%1"=="msc71" goto :add_msc7_workspaces
if "%1"=="msc70" goto :add_msc7_workspaces
if "%1"=="msc60" goto :add_msc6_workspaces
if "%1"=="msc8"  goto :add_msc8_workspaces
if "%1"=="msc9"  goto :add_msc8_workspaces
if "%1"=="msc10"  goto :add_msc8_workspaces
if "%1"=="msc11"  goto :add_msc8_workspaces
if "%1"=="msc12"  goto :add_msc8_workspaces
if "%1"=="msc14"  goto :add_msc8_workspaces
if "%1"=="msc15"  goto :add_msc8_workspaces
if "%1"=="msc16"  goto :add_msc8_workspaces

goto :skip_add_workspaces
:add_msc9_workspaces
echo Source: "demo\msc\msc8\*";  DestDir: "{app}\demo\msc\msc8"; Flags: RecurseSubDirs; Components: Demos
goto :basic_tests
:add_msc8_workspaces
echo Source: "demo\msc\msc8\*";  DestDir: "{app}\demo\msc\msc8"; Flags: RecurseSubDirs; Components: Demos
goto :basic_tests
:add_msc7_workspaces: Demos
echo Source: "demo\msc\msc70-workspaces\*"; DestDir: "{app}\demo\msc\msc70-workspaces"; Flags: RecurseSubDirs; Components: Demos
goto :basic_tests
:add_msc6_workspaces
echo Source: "demo\msc\msc60_workspaces\*"; DestDir: "{app}\demo\msc\msc60-workspaces"; Flags: RecurseSubDirs; Components: Demos
goto :basic_tests

:skip_add_workspaces
:basic_tests

if "%edition%"=="free" goto :no_tests
REM die Standard-Testprogramme werden hinzugefgt 
REM entspricht LEDA-Modul bsic

for %%f in (core coding numbers system) do echo Source: "test\%%f\*"; DestDir: "{app}\test\%%f"; Flags: RecurseSubDirs; Excludes: "\CVS,*.exe,*.obj, *.mk, *.mke, *.out, *.tds";Components: Tests


:graph_tests
REM wenn wir kein LEDA-basic sind, dann wollen wir auch die Graphentests
if "%package_size%"=="basic" goto :finish_tests

for %%f in (graph) do echo Source: "test\%%f\*"; DestDir: "{app}\test\%%f"; Flags: RecurseSubDirs; Excludes: "\CVS,*.exe,*.obj, *.mk, *.mke, *.out, *.tds";Components: Tests



:geo_tests
REM wenn wir kein LEDA-basic bzw. LEDA-graph sind, dann wollen wir auch noch die
REM geo_tests
if "%package_size%"=="basic" goto :finish_tests
if "%package_size%"=="graph" goto :finish_tests

for %%f in (geo) do echo Source: "test\%%f\*"; DestDir: "{app}\test\%%f"; Flags: RecurseSubDirs; Excludes: "\CVS,*.exe,*.obj, *.mk, *.mke, *.out, *.tds";Components: Tests


:gui_tests
REM wir sind ein gieriges Paket, wir wollen auch noch die GUI Tests
if "%package_size%"=="basic" goto :finish_tests
if "%package_size%"=="graph" goto :finish_tests
if "%package_size%"=="geometry" goto :finish_tests

for %%f in (graphics) do echo Source: "test\%%f\*"; DestDir: "{app}\test\%%f"; Flags: RecurseSubDirs; Excludes: "\CVS,*.exe,*.obj, *.mk, *.mke, *.out, *.tds";Components: Tests




:finish_tests
REM Make.pro in test/ hinzufgen
echo Source: "test\Make.pro";    	DestDir: "{app}\test"; Components: Tests

:no_tests

REM falls wir ein HTML-Manual haben, dann fgen wir es hinzu
if not exist "Manual\HTML"  goto :add_libs
for %%f in (Manual\HTML\*) do echo Source: "%%f";		DestDir: "{app}"; Components: Manual
echo.

:add_libs
REM jetzt wird das Herz der Bibliothek hinzugefgt, die Bibliotheksdateien
if "%1"=="msc71" goto :add_msc_libs
if "%1"=="msc70" goto :add_msc_libs
if "%1"=="msc60" goto :add_msc_libs
if "%1"=="bcc551" goto :add_borland_libs
if "%1"=="bcc56" goto :add_borland_libs

:add_msc_libs
REM wir bauen fr Microsoft
REM gibt es leda_md.lib
if not exist "leda_md.lib" goto :mdd_part
REM ja, hinzufgen
echo Source: "leda_md.lib";           	DestDir: "{app}"; Components: DLLs_md
echo Source: "leda_md.dll";           	DestDir: "{app}"; Components: DLLs_md

REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_md_geo
if "%package_size%"=="complete" goto :add_md_geo
goto add_md_agd
:add_md_geo
REM geowin lib hinzufgen fr md
echo Source: "libGeoW_md_dll.lib";           DestDir: "{app}"; Components: DLLs_md


:add_md_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :mdd_part
echo Source: "libAGD_md_dll.lib";           DestDir: "{app}"; Components: DLLs_md
echo.

:mdd_part
REM gibt es leda_mdd.lib
if not exist "leda_mdd.lib" goto :ml_part
REM ja, hinzufgen
echo Source: "leda_mdd.lib";           	DestDir: "{app}"; Components: DLLs_mdd
echo Source: "leda_mdd.dll";           	DestDir: "{app}"; Components: DLLs_mdd
REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_mdd_geo
if "%package_size%"=="complete" goto :add_mdd_geo
goto add_mdd_agd
:add_mdd_geo
REM geowin lib hinzufgen fr mdd
echo Source: "libGeoW_mdd_dll.lib";           DestDir: "{app}"; Components: DLLs_mdd


:add_mdd_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :ml_part
echo Source: "libAGD_mdd_dll.lib";           DestDir: "{app}"; Components: DLLs_mdd
echo.

:ml_part
REM gibt es leda_ml.lib
if not exist "leda_ml.lib" goto :mld_part
REM ja, hinzufgen
echo Source: "leda_ml.lib";           	DestDir: "{app}"; Components: DLLs_ml
echo Source: "leda_ml.dll";           	DestDir: "{app}"; Components: DLLs_ml
REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_ml_geo
if "%package_size%"=="complete" goto :add_ml_geo
goto add_ml_agd
:add_ml_geo
REM geowin lib hinzufgen fr ml
echo Source: "libGeoW_ml_dll.lib";           DestDir: "{app}"; Components: DLLs_ml


:add_ml_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :mld_part
echo Source: "libAGD_ml_dll.lib";           DestDir: "{app}"; Components: DLLs_ml
echo.

:mld_part
REM gibt es leda_mld.lib
if not exist "leda_mld.lib" goto :mt_part
REM ja, hinzufgen
echo Source: "leda_mld.lib";           	DestDir: "{app}"; Components: DLLs_mld
echo Source: "leda_mld.dll";           	DestDir: "{app}"; Components: DLLs_mld
REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_mld_geo
if "%package_size%"=="complete" goto :add_mld_geo
goto add_mld_agd
:add_mld_geo
REM geowin lib hinzufgen fr mld
echo Source: "libGeoW_mld_dll.lib";           DestDir: "{app}"; Components: DLLs_mld


:add_mld_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :mt_part
echo Source: "libAGD_mld_dll.lib";           DestDir: "{app}"; Components: DLLs_mld
echo.

:mt_part
REM gibt es leda_mt.lib
if not exist "leda_mt.lib" goto :mtd_part
REM ja, hinzufgen
echo Source: "leda_mt.lib";           	DestDir: "{app}"; Components: DLLs_mt
echo Source: "leda_mt.dll";           	DestDir: "{app}"; Components: DLLs_mt
REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_mt_geo
if "%package_size%"=="complete" goto :add_mt_geo
goto add_mt_agd
:add_mt_geo
REM geowin lib hinzufgen fr mt
echo Source: "libGeoW_mt_dll.lib";           DestDir: "{app}"; Components: DLLs_mt


:add_mt_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :mtd_part
echo Source: "libAGD_mt_dll.lib";           DestDir: "{app}"; Components: DLLs_mt
echo.

:mtd_part
REM gibt es leda_mtd.lib
if not exist "leda_mtd.lib" goto :add_rest
REM ja, hinzufgen
echo Source: "leda_mtd.lib";           	DestDir: "{app}"; Components: DLLs_mtd
echo Source: "leda_mtd.dll";           	DestDir: "{app}"; Components: DLLs_mtd
REM fr AGD-1.2 und complete brauchen wir die geowin lib
if "%package_size%"== "AGD-1.2" goto :add_mtd_geo
if "%package_size%"=="complete" goto :add_mtd_geo
goto add_mtd_agd
:add_mtd_geo
REM geowin lib hinzufgen fr mtd
echo Source: "libGeoW_mtd_dll.lib";           DestDir: "{app}"; Components: DLLs_mtd


:add_mtd_agd
REM wenn wir noch fr AGD-1.2 bauen, dann brauchen wir die AGD lib
if not "%package_size%"== "AGD-1.2" goto :add_rest
echo Source: "libAGD_mtd_dll.lib";           DestDir: "{app}"; Components: DLLs_mtd
echo.

:add_borland_libs
REM wir bauen fr den Borland Compiler

REM gibt es die statischen Libs?
if not exist "libL.lib" goto :add_bcc_dynamic
REM ja, alle hinzufgen
for %%f in (libL.lib libP.lib libG.lib libW.lib libD3.lib) do echo Source: "%%f";           	DestDir: "{app}"; Components: Libs
REM brauchen wir die geowin lib ? (AGS-1.2 und complete Pakete)
if "%package_size%"== "AGD-1.2" goto :add_bcc_geo_lib
if "%package_size%"=="complete" goto :add_bcc_geo_lib
goto add_bcc_agd_lib
:add_bcc_geo_lib
REM geowin lib hinzufgen
   echo Source: "libGeoW.lib";           	DestDir: "{app}"; Components: Libs
if "%package_size%"=="AGD-1.2" goto: add_bcc_agd_lib
goto :add_bcc_dynamic
:add_bcc_agd_lib
REM wenn wir ein AGD-Paket bauen brauchen wir die AGD-lib
if not "%package_size%"== "AGD-1.2" goto :add_bcc_dynamic
   echo Source: "libAGD.lib";           		DestDir: "{app}"; Components: Libs
:add_bcc_dynamic
REM gibt es die dynamsichen Libs?
if not exist "leda.lib" goto :add_rest
REM ja hinzufgen
echo Source: "leda.lib";           		DestDir: "{app}"; Components: DLLs
echo Source: "leda.dll";           		DestDir: "{app}"; Components: DLLs
REM brauchen wir die geowin lib?
if "%package_size%"== "AGD-1.2" goto :add_bcc_geo_lib1
if "%package_size%"=="complete" goto :add_bcc_geo_lib1
goto add_bcc_agd_lib1
:add_bcc_geo_lib1
REM Geowin lib hinzufgen
   echo Source: "libGeoW_dll.lib";           	DestDir: "{app}"; Components: DLLs
if "%package_size%"=="AGD-1.2" goto: add_bcc_agd_lib1
goto :add_rest
:add_bcc_agd_lib1
REM AGD lib fr AGD-Paket hinzufgen
if not "%package_size%"== "AGD-1.2" goto :add_rest
   echo Source: "libAGD_dll.lib";           		DestDir: "{app}"; Components: DLLs

:add_rest
REM alle Bibliotheksdateien sind angefgt, nun brauchen wir nur noch diverse
REM Textdateien
if "%package_size%"== "AGD-1.2" goto :add_batch_makefiles_all
if "%package_size%"=="complete" goto :add_batch_makefiles_all
if "%package_size%"=="geometry" goto :add_batch_makefiles_all
if "%package_size%"=="graph"    goto :add_batch_makefiles_test
goto :add_FIXES
:add_batch_makefiles_all
REM die Batch-files zum Bauen der Demo- und Testprogramme
echo Source: "make_demo.bat";         	DestDir: "{app}"; Components: Demos
echo Source: "make_test.bat";        	DestDir: "{app}"; Components: Tests
echo.
goto :add_FIXES
:add_batch_makefiles_test
echo Source: "make_test.bat";        	DestDir: "{app}"; Components: Tests
echo.
:add_FIXES
REM FIXES, CHANGES, die Install-Hilfen, das Readme und die Lizenz
echo Source: "CHANGES";         	DestDir: "{app}"; Components: main
echo Source: "FIXES";         		DestDir: "{app}"; Components: main
echo Source: "Install\*.txt"; DestDir: "{app}\Install"; Components: main
echo.
echo Source: "Readme.txt";         		DestDir: "{app}"; Flags:isreadme; Components: main
echo Source: "license.txt";         		DestDir: "{app}"; Components: main
echo.
REM Nun fehlen der ISS-Datei nur noch die [Icons]-Gruppe (Startmenentrag!)
REM dort stehen Verweis aufs HTML Manual, Readme, Verweis auf demo-Verzeichnis,
REM HTML-Link auf unsere Webseite
echo [Icons]
echo Name: "{group}\Installation"; Filename: "{app}\Readme.txt"
if "%package_size%"== "AGD-1.2" goto :add_demo_dir_group
if "%package_size%"=="complete" goto :add_demo_dir_group
goto :add_html_link
:add_demo_dir_group
echo Name: "{group}\Demo Directory";        Filename: "{app}\demo"
:add_html_link
echo Name: "{group}\Algorithmic Solutions";Filename: "http://www.algorithmic-solutions.com"
echo.

:add_registry_entry
REM dieser Eintrag setzt spter automatisch die LEDAROOT Variable
echo [Registry]
echo Root: HKCU; Subkey: "Environment"; ValueName: "LEDAROOT"; ValueData: "{app}"; Flags: uninsdeletevalue; ValueType: string; Components: main;
REM nun gehn wir heim
goto :quit



:quit