#include <LEDA/sortseq.h>
#include <LEDA/stream.h>

using namespace leda;

using std::ostream;
using std::istream;
using std::cout;
using std::endl;
using std::cin;

class Pair {

 double  x;
 double  y;

public:

Pair() { x = y = 0; }
Pair(const Pair& p) { x = p.x; y = p.y; }

double xc() const { return x; }
double yc() const { return y; }

friend istream& operator>>(istream& is, Pair& p)
{ return is >> p.x >> p.y; }

friend ostream& operator<<(ostream& os, const Pair& p)
{ return os << p.x << " " << p.y; }

};


namespace leda {
int compare(const Pair& p, const Pair& q)
{  if (p.xc() < q.xc()) return -1; 
   if (p.xc() > q.xc()) return  1; 
   if (p.yc() < q.yc()) return -1; 
   if (p.yc() > q.yc()) return  1; 
   return 0;  
 }
}



void print(sortseq<Pair,int>& S)
{ seq_item it;
  cout << S.size() << endl;
  forall_items(it,S) cout << S.key(it) << endl;
  cout << endl;
}

void print1(sortseq<Pair,int> S)
{
  cout << S.size() << endl;
  while( !S.empty() )
  { seq_item it = S.min();
    cout << S.key(it) << endl;
    S.del_item(it);
   }
  cout << endl;
}


main()
{
  sortseq<Pair,int> S,S1,S2;

  file_istream input(read_string("file name: "));

  Pair s;

  while (input >> s)  S.insert(s,0);

  cout << S.size() << " strings.\n\n";


  print(S);

  Pair s1,s2;

  do { cin >> s1 >> s2;

       seq_item it1 = S.locate(s1);

       seq_item it2 = S.locate(s2);
     
       while (it1!=it2)
         { cout << S.key(it1) << "\n"; 
           it1 = S.succ(it1);
          }

     } while (s1.xc() != 0 || s1.yc() != 0);
    

  return 0;
}
