
#define LEDA_CHECKING_OFF

#include <LEDA/graph.h>
#include <LEDA/graph_alg.h>
#include <LEDA/dimacs.h>
#include <LEDA/stream.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::cerr;
using std::endl;
#endif



int main(int argc, char** argv) 
{
  if (argc < 2)
  { cerr << "usage: " << argv[0] << " n" << endl;
    return 1;
   }

  GRAPH<int,int> G;
  edge_array<int>& cap = G.edge_data();
  node s,t;

  int n = atoi(argv[1]);

  max_flow_gen_CG2(G,s,t,n);
  Write_Dimacs_Maxflow(cout,G,cap,s,t);
    
 return 0;
}
