
#define LEDA_CHECKING_OFF

#include <LEDA/graph.h>
#include <LEDA/graph_alg.h>
#include <LEDA/dimacs.h>
#include <LEDA/stream.h>


using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::cin;
using std::cerr;
using std::flush;
using std::endl;
#endif



int main(int argc, char** argv) 
{
  if (argc < 2)
  { cerr << "usage: argv[0] n (m)" << endl;
    return 1;
   }

  GRAPH<int,int> G;
  edge_array<int>& cap = G.edge_data();
  node s,t;

  int n = atoi(argv[1]);
  int m = int(sqrt(n)*n/2);

  if (argc >= 3) m = atoi(argv[2]);

  rand_int.set_seed(n*m);

  max_flow_gen_rand(G,s,t,n,m);
  //Delete_Loops(G);
  Write_Dimacs_Maxflow(cout,G,cap,s,t);
    
 return 0;
}
