#include <LEDA/d3_window_stream.h>

int main()
{
 d3_window_stream DW("Test");
 d3_point p(100,200,100);
 d3_point p1(80,50,10),p2(120,130,15);
 d3_line seg(p1,p2);
 d3_plane pl(p,p1,p2);
 
 DW.set_color(red);
 
 DW << p;
 DW << seg;
 DW << pl;

 // d3 simplex ...
 d3_point ps1(20,30,30),ps2(70,10,-10);
 d3_point ps3(50,10,100),ps4(60,100,30);
 d3_simplex sim(ps1,ps2,ps3,ps4);
 
 DW.set_color(red);
 DW << sim;
 
 // d3 sphere ...
 vector vec(90,40,30);
 d3_sphere sph(ps1+vec, ps2+vec, ps3+vec, ps4+vec);
 
 DW.set_color(green2);
 //DW << sph;
 
 // d2 types ...
 point pa(100,100), pb(200,200);
 segment s(pa,pb);
 ray  ri(pa,pb);
 
 DW.set_color(black);
 DW << pa << pb;
 DW << s;
 DW << ri;
 
 list<point> PL;
 point pc(500,700), pd(0,400);
 PL.append(pa); PL.append(pb); PL.append(pc); PL.append(pd);
 
 DW << polygon(PL);
 
 point pc1(200,200), pc2(500,200), pc3(200,500);
 circle circ(pc1,pc2,pc3);
 
 DW.set_color(blue);
 polygon pol = hilbert(3,-200,-200,400,400);
 DW << pol;
 
 DW.set_color(green);
 DW << circ;
 
 DW.set_color(blue2);
 rectangle rect(-500,-400,-100,-30);
 DW << rect;
 
 DW.show();
 
 //DW.show();
 return 0;
}
