#include <LEDA/graph/graph.h>
#include <LEDA/graph/static_graph.h>
#include <LEDA/graph/dimacs_graph.h>
#include <LEDA/system/assert.h>

#include <LEDA/graph/node_slot.h>
#include <LEDA/graph/edge_slot.h>



using namespace leda;

using std::cout;
using std::cin;

int main(int argc, char** argv)
{
  typedef static_graph<opposite_graph,data_slots<1>,data_slots<3> > st_graph;
  //typedef st_graph::node node;

  st_graph G;
  node_slot<int,st_graph,0>  supply(G);
  edge_slot<int,st_graph,0>  lcap(G);
  edge_slot<int,st_graph,1>  ucap(G);
  edge_slot<int,st_graph,2>  cost(G);

  dimacs_mcf D(cin);
  D.translate(G,supply,lcap,ucap,cost);

  write_dimacs_mcf(cout,G,supply,lcap,ucap,cost);

  return 0;
}

