#include "my_boost.h"
#include "cm_rec.h"
#include "cm_nonrec.h"
#include "tarjan_rec.h"
#include "tarjan_nonrec.h"

#include "dfsnum.h"

#include <iomanip>


enum vertex_compnum_t { vertex_compnum };

namespace boost {
  BOOST_INSTALL_PROPERTY(vertex, compnum);
}


using namespace std;


int main(int argc, char* argv[])
{

  typedef boost::adjacency_list<boost::vecS,boost::vecS,boost::directedS,
                                property<vertex_compnum_t,int> > Graph;

  typedef graph_traits <Graph> traits;
  typedef traits::vertex_descriptor node;
  typedef traits::vertex_iterator   node_it;
  typedef traits::out_edge_iterator out_edge_it;


  typedef boost_graph<Graph> graph;

  graph G;

  typedef property_map < Graph, vertex_compnum_t >::type node_slot;

  node_slot compNum = get(vertex_compnum, G);

/*
  typedef boost::adjacency_list<boost::vecS,boost::vecS,boost::directedS> Graph;
  typedef graph_traits <Graph> traits;

  typedef traits::vertex_iterator   node;
  typedef traits::out_edge_iterator edge;

  typedef boost_graph<Graph> graph;

  graph G;
*/

  int d = 10; //cout << "d = "; cin >> d;

/*
int m = 1 << 23;   // 8 Mio

cout << endl;
cout << "m = " << m << endl;
cout << endl;
*/

  cout << "   n     BCM0  BCMrc BCMrc BCMnr BTa0  BTarc BTarc BTanr BDFS" << endl;

  cout <<  fixed << setw(5) << setprecision(2) << right;

/*
for (double f = m;  f*(f-1) >= m;  f/=2) 
{
    int n = int(f);
*/


for(int n = 100000; n<2000000; n += 100000)
{ 
  int m = d*n;

  cout << setw(7) << n << " " << flush;


  random_graph(G,n,m);

  node_array<int,graph> compNum0(G);
  node_array<int,graph> compNum(G);




  float T = used_time();



{
  STRONG_COMPONENTS_CM0<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}

{
  STRONG_COMPONENTS_CM1<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}

{
  STRONG_COMPONENTS_CM2<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}


{
  STRONG_COMPONENTS_CM_NR2<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}


{
  STRONG_COMPONENTS_TARJAN0<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}

{
  STRONG_COMPONENTS_TARJAN1<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}

{
  STRONG_COMPONENTS_TARJAN2<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}


{
  STRONG_COMPONENTS_TARJAN_NR2<graph> SCC;
  int scc = SCC(G,compNum);
  cout << setw(5) << SCC.cpu_time() << " " << flush;
}


{
  DFS_NUM<graph> dfs;
  int s = dfs(G,compNum);
  cout << setw(5) << dfs.cpu_time() << " " << flush;
}


  cout << endl;

}

  return 0;
}

 
