#include "my_boost.h"
#include "cm_rec.h"
#include "cm_nonrec.h"
#include "tarjan_rec.h"
#include "tarjan_nonrec.h"

#include "dfsnum.h"

#include <iomanip>

using namespace std;


int main(int argc, char* argv[])
{
  typedef boost::adjacency_list<boost::vecS,boost::vecS,boost::directedS> Graph;
  typedef graph_traits <Graph> traits;

  typedef traits::vertex_iterator   node;
  typedef traits::out_edge_iterator edge;

  typedef boost_graph<Graph> graph;

int m = 1 << 23;   // 8 Mio

cout << endl;
cout << "m = " << m << endl;
cout << endl;
cout << "BOOST builtin" << endl;
cout << endl;


for (double f = m;  f*(f-1) >= m;  f/=2) 
{
    int n = int(f);



/*
for(int n = 100000; n < 1000000; n += 100000)
{
  int m = 10*n;
*/


  graph G;

  random_graph(G,n,m);

  node_array<int,graph> compNum0(G);

  cout <<  fixed << setw(5) << setprecision(2) << right;


  float T = used_time();

  boost::strong_components(G, 
             make_iterator_property_map(compNum0.begin(),get(vertex_index, G)));

  cout << setw(7) << n << "  " << setw(5) << fixed << setprecision(3) << used_time(T) << endl; 


}

  return 0;
}

 
