#include <iostream>

#define CACHE_LINE 64

#define CACHE_ALIGN __declspec(align(CACHE_LINE))

void sortXMM8Short(short int *val /*xmm aligned*/ )
{

static const __int64 CACHE_ALIGN consts[10] =
{
0xffff0000ffff0000, 0xffff0000ffff0000,
0x0000ffff0000ffff, 0x0000ffff0000ffff,
0x000000000000ffff, 0xffff000000000000,
0x0000ffff00000000, 0x0000ffff0000ffff,
0xffff0000ffff0000, 0x00000000ffff0000,
};
__asm
{
mov edx, [val] ; get the pointer
lea eax, [consts]
movdqa xmm0, [edx] ; fetch 8 shorts
mov ecx, 4 ; number of runs
align 16
swaprun:
// conditional swap of 4 even pairs 0-1,2-3,...,7-8
movdqa xmm1, xmm0
movdqa xmm2, xmm0
pslldq xmm0, 2 ; one word left
psrldq xmm1, 2 ; one word right
pmaxsw xmm0, xmm2
pminsw xmm1, xmm2
pand xmm0, [eax+0*16]; ffff0000ffff0000:ffff0000ffff0000 max
pand xmm1, [eax+1*16]; 0000ffff0000ffff:0000ffff0000ffff min
por xmm0, xmm1 ; combine even max:min
// conditional swap of 3 odd pairs 1-2,3-4,...,14-15
movdqa xmm1, xmm0
movdqa xmm2, xmm0
pslldq xmm0, 2
psrldq xmm1, 2
pmaxsw xmm0, xmm2
pminsw xmm1, xmm2
pand xmm2, [eax+2*16]; ffff000000000000:000000000000ffff
pand xmm0, [eax+3*16]; 0000ffff0000ffff:0000ffff00000000 max
pand xmm1, [eax+4*16]; 00000000ffff0000:ffff0000ffff0000 min
por xmm0, xmm2 ; combine odd pairs and outer words
por xmm0, xmm1
dec ecx ; next run ?
jnz swaprun
movdqa [edx], xmm0 ; write sorted array
}
}


int main()
{
   short int A[] = {8,7,6,5,4,3,2,1};

   sortXMM8Short(A;)

   for(int i=0; i<8; i++) std::cout << i << " ";
   std::cout << std::endl;
}
